// MessageBalloonDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MessageBalloon.h"
#include "MessageBalloonDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMessageBalloonDlg dialog

CMessageBalloonDlg::CMessageBalloonDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMessageBalloonDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMessageBalloonDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMessageBalloonDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMessageBalloonDlg)
	DDX_Control(pDX, IDC_EDIT1, m_EditBox);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMessageBalloonDlg, CDialog)
	//{{AFX_MSG_MAP(CMessageBalloonDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMessageBalloonDlg message handlers

BOOL CMessageBalloonDlg::OnInitDialog()
{
	CDialog::OnInitDialog();


	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMessageBalloonDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMessageBalloonDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMessageBalloonDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMessageBalloonDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CString szMessage;
	m_EditBox.GetWindowText(szMessage);

	if(szMessage.GetLength() == 0)
	{
		CreateBalloon(IDC_EDIT1);
		return ;
	}

	CDialog::OnOK();
}


void CMessageBalloonDlg::CreateBalloon(int nItemID)
{

	CRect rect;


	GetDlgItem(nItemID)->GetWindowRect(&rect);

	DisplayBalloon(&rect, "Please enter a value or cancel this dialog.");


}

void CMessageBalloonDlg::DisplayBalloon(CRect * lpRect, const CString & szMessage)

{
	if(lpRect != 0)
	{
		CRect ClientRect;
		this->GetWindowRect(&ClientRect);
		LOGFONT lf;
        ::ZeroMemory (&lf, sizeof (lf));
        lf.lfHeight = 16;
        lf.lfWeight = FW_BOLD;
        lf.lfUnderline = FALSE;
        ::strcpy (lf.lfFaceName, _T("Arial"));

		CPoint pt = lpRect->CenterPoint();
		HDC hdc = ::GetDC(this->m_hWnd);

		TEXTMETRIC tm;
		GetTextMetrics(hdc, &tm);

		int nWidth = tm.tmAveCharWidth;
		int nHeight = tm.tmHeight;

		GetClientRect(lpRect);

		m_pBalloonTip = CBalloonTip::Show(pt, /*&ClientRect,*/ lpRect, nWidth, nHeight, 
			szMessage, lf, 5, TRUE);
	}

}
